#include <sstream>
#include <set>

#include "testlib.h"

using namespace std;

int main(int argc, char *argv[])
{
    registerValidation(argc, argv);

    int N = inf.readInt(1, 100000, "N"); inf.readSpace();
    int M = inf.readInt(0, 200000, "M"); inf.readEoln();

    for (int i = 1; i <= M; i++)
    {
        int a = inf.readInt(1, N, "Edge endpoint"); inf.readSpace();
        int b = inf.readInt(1, N, "Edge endpoint"); inf.readSpace();
        inf.readInt(1, 2, "Edge color"); inf.readEoln();

        // Self loops are possible
        // Multi edges are possible
    }

    inf.readEof();

    if (validator.group() == "0")
    {
    }
    else if (validator.group() == "1")
    {
        ensure(N <= 5 && M <= 14);
    }
    else if (validator.group() == "2")
    {
        ensure(N <= 100);
    }
    else if (validator.group() == "3")
    {
        ensure(N <= 1000);
    }
    else if (validator.group() == "4")
    {
        ensure(N <= 10000);
    }
    else if (validator.group() == "5")
    {
        // No further constraints
    }
}
